# minigame-framework

#### 介绍
laya游戏项目框架，封装了基本游戏流程，如加载->开始游戏，复活，失败结算，胜利结算。并提供了自定义游戏流程的功能

#### 文件及目录说明
1. fc.define.laya.js: 事件及枚举的定义
2. fc.framework.laya.js: 框架的主要实现
3. fc.lugin.laya.js: 常用的工具类
4. adapter: 平台及渠道适配器目录。各平台渠道的登录、广告和硬件接口适配
5. deploy: 游戏流程设置目录。提供了几套游戏流程的实现

#### 使用说明
1. 添加到项目：在项目的bin目录中添加fc-framework子模块
2. 项目中引用: 在bin/index.js中加载需要框架文件

#### API说明
* fc.define.Event
* fc.define.SceneId
* fc.define.Layout
* fc.define.LoadingStep
* fc.framework.Audio
    * static playMusic(music: string);
    * static stopMusic();      
    * static playSound(soundId: string, isLoop: boolean);
    * static stopSound(soundId: string);
    * static stopAll();
    * static stopAllSound();
    * static musicMuted: boolean;
    * static musicVolume: number;
    * static soundMuted: boolean;
    * static soundVolume: number;
* fc.framework.Device
    * static statusBarHeight: number
    * static screenWidth: number
    * static screenHeight: number
    * static playSound(res: string, loop: boolean, compHandler: Laya.Handler)
    * static stopSound(res: string)
    * static playMusic(res: string)
    * static stopMusic()
    * static stopAll();
    * static stopAllSound()
    * static vibrateShort()
    * static vibrateLong()
    * static isNetValid(): boolean
* fc.framework.Channel
    * static login(successHandler: Laya.Handler, failedHandler: Laya.Handler)
    * static loadSubpackage(pkgName: string, progressHandler: Laya.Handler, successHandler: Laya.Handler, failedHandler: Laya.Handler)
    * static initVideoAd(adUnitId: string)
    * static playVideo(completedHandler: Laya.Handler, interuptHandler: Laya.Handler, errorHandler: Laya.Handler)
    * static isVideoEnable(): boolean
    * static openShare(text: string, imgUrl: string)
    * static initInsertAd(adUnitId: string, errorHandler: Laya.Handler)
    * static loadInsertAd(loadedHandler: Laya.Handler, errorHandler: Laya.Handler)
    * static showInsertAd(closeHandler: Laya.Handler)
    * static initBannerAd(adUnitId: string, bannerAdScale: number, bannerLiveTime: number, errorHandler: Laya.Handler)
    * static showBannerAd(posY: number, errorHandler: Laya.Handler)
    * static hideBannerAd()
    * static navigate2Mini(appId: string, path: string, extraData: string, success: Function, failed: Function, completed: Function)
* fc.framework.Resource
    * static curScene3dUrl: string
    * static get3dResUrl(filename: string): string
    * static get3dPrefabUrl(filename: string): string
    * static get3dSceneUrl(filename: string): string
    * static loadSubpackage(subpkg: string, onCompleted: Laya.Handler, onProgress: Laya.Handler)
    * static loadFont(fontUrl: string, onCompleted: Laya.Handler, onProgress: Laya.Handler)
    * static loadRes(resPath: string): any
    * static loadResAsyn(resPath: string, onCompleted: Laya.Handler, onProgress: Laya.Handler, pkgName: string)
    * static load3dRes(resPath: string): any
    * static load3dResAsyn(resPath: string, onCompleted: Laya.Handler, onProgress: Laya.Handler, pkgName: string)
    * static loadSprite3d(resPath: string): Laya.Sprite3D
    * static loadSprite3dAsyn(resPath: string, onCompleted: Laya.Handler, onProgress: Laya.Handler, pkgName: string)
    * static loadScene3d(resPath: string): Laya.Scene3D
    * static loadScene3dAsyn(resPath: string, onCompleted: Laya.Handler, onProgress: Laya.Handler, pkgName: string)
    * static unloadSceneRes(sceneUrl: string)
* fc.framework.Md5Utils
    * static hex_md5(s)
    * static b64_md5(s)
    * static str_md5(s)
    * static hex_hmac_md5(key, data)
    * static b64_hmac_md5(key, data)
    * static str_hmac_md5(key, data)
* fc.framework.MiscUtils
    * static compareVersion(left: string, right: string)
    * static isToday(val: number)
    * static isNumber(val: number | string)
    * static array2UrlStrArgs(args:any[])
    * static object2UrlStrArgs(args:any)
    * static random(min, max)
* fc.framework.WebRequest
    * static getArgsSign(agrs: any, secret: string): string
    * static xhrPost(api: string, args: any)
    * static xhrPostWithSign(api: string, args: any, secret: string)
    * static xhrPostWithSignAndHeader(api: string, args: any, secret: string, headerInfo: any)
* fc.framework.FrameConfig
    * version: string;
    * versionNum: number;
    * appId: string;
    * appName: string;
    * channel: string;
    * subpackage: string[];
    * netBaseCfgUrl: string;
    * netAdCfgUrl: string;
    * configList: string[];
    * fontList: string[];
    * baseResList: string[];
    * bgm: string;
    * soundClick: string;
    * default3DScene: string;
* fc.framework.GameHook
    * onLaunchResReady(callback: Laya.Handler)
    * on2Home(data, callback: Laya.Handler)
    * on2Game(data, callback: Laya.Handler)
    * onRelive(data, callback: Laya.Handler)
    * onShowFailed(data, callback: Laya.Handler)
    * onShowSuccessed(data, callback: Laya.Handler)
    * onGameOver(data, callback: Laya.Handler)
    * onViewOpened(viewName: string, view: Laya.View)
    * onViewClosed(viewName: string)
* fc.framework.GameFrame
    * static appConfig: FrameConfig
    * static playerInfo: any
    * static gameCfg: any
    * static pluginCfg: any
    * static viewCfg: any
    * static reliveChance: number
    * static autoStartNext: boolean
    * static isWin: boolean
    * static hook: GameHook
    * static scene3d: Laya.Scene3D
    * static startUp()
    * static pause()
    * static resume()
    * static openView(viewId: string, data: any, callback: Laya.Handler, closeOther: boolean)
    * static closeView(viewId: string)
    * static showLoading(data: any, callback: Laya.Handler)
    * static go2Home(data: any, callback: Laya.Handler)
    * static go2Game(data: any, callback: Laya.Handler)
    * static showSuccessed(data: any, callback: Laya.Handler)
    * static showFailed(data: any, callback: Laya.Handler)
    * static overGame(data: any)
    * static go2Relive(data: any)
    * static startGame()
    * static savePlayerInfo(data: any)
    * static playClickSound()
    * static showToastMsg(msg: string)
    * static showMessageBox(msg: string, confirm: Laya.Handler)
* fc.plugin.ObjectPool
    * static recoverSprite3d(sprite3d: Laya.Sprite3D)
    * static getSprite3d(original: Laya.Sprite3D, sign: string): Laya.Sprite3D
    * static getEmptySprite3d(sign: string): Laya.Sprite3D
* fc.plugin.BaseView
* fc.plugin.Effect3dInfo
    * customId: string
    * sign: string
    * duaration: number
    * parent: Laya.Node
    * isWorldSpace: boolean
    * position: Laya.Vector3
    * rotation: Laya.Quaternion
    * script: any
* fc.plugin.Effect3d
    * static createEffect(effectInfo: Effect3dInfo)
* fc.plugin.Trigger3dListenerInterface
    * on3dTriggerEnter(other)
    * on3dTriggerExit(other)
    * on3dTriggerStay(other)
* fc.plugin.Trigger3dListener
    * static add(sprite3d: Laya.Sprite3D, listener: Trigger3dListenerInterface)
    * static remove(sprite3d: Laya.Sprite3D, listener: Trigger3dListenerInterface)
* fc.plugin.AnimEventListenerInterface
    * onAnimEvt(...args)
* fc.plugin.AnimEventListener
    * static init(animator: Laya.Animator, listener: AnimEventListenerInterface)
* fc.plugin.AnimStateListenerInterface
    * onAnimStateEnter(stateName: string, animator: Laya.Animator)
    * onAnimStateUpdate(stateName: string, animator: Laya.Animator)
    * onAnimStateExit(stateName: string, animator: Laya.Animator)
* fc.plugin.AnimStateListener
    * static add(animator: Laya.Animator, stateName: string, listener: AnimStateListenerInterface)
    * static remove(animator: Laya.Animator, stateName: string, listener: AnimStateListenerInterface)
* fc.plugin.TextureCamera
    * static RenderTexture: Laya.RenderTexture
* fc.plugin.BannerCtrl
    * static bannerConfig: any
* fc.plugin.AdditiveUICtrl
    * static additiveUIConfig: any
    * static checkFun: (code: number)=>{}
