/**
 * 设置LayaNative屏幕方向，可设置以下值
 * landscape           横屏
 * portrait            竖屏
 * sensor_landscape    横屏(双方向)
 * sensor_portrait     竖屏(双方向)
 */

window.screenOrientation = "sensor_landscape";
var platform = "hw"; // "wx,oppo,vivo,qq,byte,h5";
var channel = null; // "tapon";

//-----libs-begin-----
require("./libs/min/laya.core.min.js")
require("./libs/min/laya.ui.min.js")
require("./libs/min/laya.d3.min.js")
require("./libs/min/laya.physics3D.min.js")
//-----libs-end-------

require("./fc-framework/fc.define.js");
require("./fc-framework/fc.framework.js");
require("./fc-framework/fc.plugin.js");
require("./fc-framework/fc.ad.export.js");
require("./fc-framework/platform/fc.view.js");
require(`./fc-framework/adapter/fc.${platform}.js`);

var scriptUrl = platform;
if (scriptUrl == "native" && typeof fcn !== "undefined" && fcn.getScriptUrl != null) {
    scriptUrl = fcn.getScriptUrl();
}
if (scriptUrl != null && scriptUrl != "" && scriptUrl != platform) {
    loadLib(scriptUrl);
}
else {
    require(`./fc-framework/platform/fc.${platform}.js`);
}

require("./js/bundle.js");
